<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>FCMUtil xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../apidocs/org/eclipse/papyrus/designer/components/FCM/util/FCMUtil.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.components.FCM.util;
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <strong class="jxr_keyword">import</strong> java.util.HashMap;
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <strong class="jxr_keyword">import</strong> java.util.Iterator;
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <strong class="jxr_keyword">import</strong> java.util.List;
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.CoreException;
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.IConfigurationElement;
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.IExtensionRegistry;
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.Platform;
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.EList;
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.UniqueEList;
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.EObject;
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.components.FCM.Connector;
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.components.FCM.ContainerRule;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.components.FCM.InteractionComponent;
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.components.FCM.RuleApplication;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.components.FCM.profile.IEmbeddingRule;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Class;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.CollaborationUse;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.ConnectableElement;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Element;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.InstanceSpecification;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Interface;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Slot;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.UMLFactory;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.ValueSpecification;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/components/FCM/util/FCMUtil.html">FCMUtil</a> {
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <em class="jxr_javadoccomment">	 * @param specification</em>
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <em class="jxr_javadoccomment">	 * @param configPropertyName</em>
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> EList&lt;ValueSpecification&gt; getConfigurationValue(InstanceSpecification specification, String configPropertyName) {
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  		<strong class="jxr_keyword">if</strong> (specification != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  			<strong class="jxr_keyword">for</strong> (Iterator&lt;Slot&gt; i = specification.getSlots().iterator(); i.hasNext();) {
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  				Slot currentSlot = i.next();
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  				<strong class="jxr_keyword">if</strong> (currentSlot.getDefiningFeature() != <strong class="jxr_keyword">null</strong> &amp;&amp;
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  						currentSlot.getDefiningFeature().getName().equals(configPropertyName)) {
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  					<strong class="jxr_keyword">return</strong> currentSlot.getValues();
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  				}
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  			}
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  		}
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  	}
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  <em class="jxr_javadoccomment">	 * @param interfaces</em>
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  <em class="jxr_javadoccomment">	 * @param interfaceName</em>
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Interface findInterfaceByName(EList&lt;Interface&gt; interfaces, String interfaceName) {
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  		<strong class="jxr_keyword">for</strong> (Iterator&lt;Interface&gt; i = interfaces.iterator(); i.hasNext();) {
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  			Interface currentInterface = i.next();
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  			<strong class="jxr_keyword">if</strong> (currentInterface.getName().equals(interfaceName)) {
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  				<strong class="jxr_keyword">return</strong> currentInterface;
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  			}
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  		}
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  	}
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  <em class="jxr_javadoccomment">	 * A data structure to be used for the specification of how the roles of the collaboration associated with</em>
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  <em class="jxr_javadoccomment">	 * the type of param "connector" are bound to actual elements of the composite containing param "connector".</em>
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  <em class="jxr_javadoccomment">	 * This data structure contains an hashmap&lt;ConnectableElement, List&lt;Element&gt;&gt;:</em>
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  <em class="jxr_javadoccomment">	 * - keys must be roles of a Collaboration</em>
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  <em class="jxr_javadoccomment">	 * - values must be list of elements playing this role in the context of a particular composite</em>
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  <em class="jxr_javadoccomment">	 * @author ac221913</em>
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/components/FCM/util/FCMUtil.html">RoleBindingTable</a> {
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  		<strong class="jxr_keyword">private</strong> HashMap&lt;org.eclipse.uml2.uml.ConnectableElement, List&lt;org.eclipse.uml2.uml.NamedElement&gt;&gt; table;
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  		<strong class="jxr_keyword">public</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/components/FCM/util/FCMUtil.html">RoleBindingTable</a>() {
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  			<strong class="jxr_keyword">this</strong>.table = <strong class="jxr_keyword">new</strong> HashMap&lt;org.eclipse.uml2.uml.ConnectableElement,
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  					List&lt;org.eclipse.uml2.uml.NamedElement&gt;&gt;();
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  		}
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  		<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> addEntry(org.eclipse.uml2.uml.ConnectableElement role,
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  				List&lt;org.eclipse.uml2.uml.NamedElement&gt; playedBy) {
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  			table.put(role, playedBy);
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  		}
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  		<strong class="jxr_keyword">public</strong> List&lt;org.eclipse.uml2.uml.NamedElement&gt; getEntry(org.eclipse.uml2.uml.ConnectableElement role) {
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  			<strong class="jxr_keyword">return</strong> table.get(role);
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  		}
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  		<strong class="jxr_keyword">public</strong> Iterator&lt;org.eclipse.uml2.uml.ConnectableElement&gt; iterator() {
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  			<strong class="jxr_keyword">return</strong> table.keySet().iterator();
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  		}
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  		<strong class="jxr_keyword">public</strong> HashMap&lt;org.eclipse.uml2.uml.ConnectableElement, List&lt;org.eclipse.uml2.uml.NamedElement&gt;&gt; getTable() {
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  			<strong class="jxr_keyword">return</strong> table;
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  		}
<a class="jxr_linenumber" name="L100" href="#L100">100</a> 
<a class="jxr_linenumber" name="L101" href="#L101">101</a> 		<strong class="jxr_keyword">public</strong> ConnectableElement getRoleKeyByName(String roleName) {
<a class="jxr_linenumber" name="L102" href="#L102">102</a> 			<strong class="jxr_keyword">for</strong> (ConnectableElement role : table.keySet()) {
<a class="jxr_linenumber" name="L103" href="#L103">103</a> 				<strong class="jxr_keyword">if</strong> (role.getName().equals(roleName)) {
<a class="jxr_linenumber" name="L104" href="#L104">104</a> 					<strong class="jxr_keyword">return</strong> role;
<a class="jxr_linenumber" name="L105" href="#L105">105</a> 				}
<a class="jxr_linenumber" name="L106" href="#L106">106</a> 			}
<a class="jxr_linenumber" name="L107" href="#L107">107</a> 			<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 		}
<a class="jxr_linenumber" name="L109" href="#L109">109</a> 	}
<a class="jxr_linenumber" name="L110" href="#L110">110</a> 
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L112" href="#L112">112</a> <em class="jxr_javadoccomment">	 * Generate a connection pattern. Currently unused</em>
<a class="jxr_linenumber" name="L113" href="#L113">113</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L114" href="#L114">114</a> <em class="jxr_javadoccomment">	 * @param connectorComp</em>
<a class="jxr_linenumber" name="L115" href="#L115">115</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L116" href="#L116">116</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> generateDefaultConnectionPattern(<a href="../../../../../../../org/eclipse/papyrus/designer/components/FCM/InteractionComponent.html">InteractionComponent</a> connectorComp) {
<a class="jxr_linenumber" name="L117" href="#L117">117</a> 		org.eclipse.uml2.uml.Collaboration connectionPattern =
<a class="jxr_linenumber" name="L118" href="#L118">118</a> 				UMLFactory.eINSTANCE.createCollaboration();
<a class="jxr_linenumber" name="L119" href="#L119">119</a> 
<a class="jxr_linenumber" name="L120" href="#L120">120</a> 		<em class="jxr_comment">// ((org.eclipse.uml2.uml.Package)connectorComp.getBase_Class().getOwner()).getPackagedElements().add(connectionPattern) ;</em>
<a class="jxr_linenumber" name="L121" href="#L121">121</a> 		connectorComp.getBase_Class().getNestedClassifiers().add(connectionPattern);
<a class="jxr_linenumber" name="L122" href="#L122">122</a> 		connectionPattern.setName(connectorComp.getBase_Class().getName() + <span class="jxr_string">"ConnectionPattern"</span>); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L123" href="#L123">123</a> 
<a class="jxr_linenumber" name="L124" href="#L124">124</a> 		org.eclipse.uml2.uml.Property connectorRole =
<a class="jxr_linenumber" name="L125" href="#L125">125</a> 				connectionPattern.createOwnedAttribute(<span class="jxr_string">"connector"</span>, connectorComp.getBase_Class(), 1, 1); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L126" href="#L126">126</a> 		<strong class="jxr_keyword">for</strong> (Iterator&lt;org.eclipse.uml2.uml.Port&gt; i = connectorComp.getBase_Class().getOwnedPorts().iterator(); i.hasNext();) {
<a class="jxr_linenumber" name="L127" href="#L127">127</a> 			org.eclipse.uml2.uml.Port port = i.next();
<a class="jxr_linenumber" name="L128" href="#L128">128</a> 			org.eclipse.uml2.uml.Property role;
<a class="jxr_linenumber" name="L129" href="#L129">129</a> 			org.eclipse.uml2.uml.Connector connector;
<a class="jxr_linenumber" name="L130" href="#L130">130</a> 			role = connectionPattern.createOwnedAttribute(port.getName(), <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L131" href="#L131">131</a> 			connector = connectionPattern.createOwnedConnector(<span class="jxr_string">""</span>); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L132" href="#L132">132</a> 			org.eclipse.uml2.uml.ConnectorEnd source, target;
<a class="jxr_linenumber" name="L133" href="#L133">133</a> 			source = connector.createEnd();
<a class="jxr_linenumber" name="L134" href="#L134">134</a> 			source.setRole(port);
<a class="jxr_linenumber" name="L135" href="#L135">135</a> 			source.setPartWithPort(connectorRole);
<a class="jxr_linenumber" name="L136" href="#L136">136</a> 			target = connector.createEnd();
<a class="jxr_linenumber" name="L137" href="#L137">137</a> 			target.setRole(role);
<a class="jxr_linenumber" name="L138" href="#L138">138</a> 		}
<a class="jxr_linenumber" name="L139" href="#L139">139</a> 
<a class="jxr_linenumber" name="L140" href="#L140">140</a> 		connectorComp.setConnectionPattern(connectionPattern);
<a class="jxr_linenumber" name="L141" href="#L141">141</a> 	}
<a class="jxr_linenumber" name="L142" href="#L142">142</a> 
<a class="jxr_linenumber" name="L143" href="#L143">143</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L144" href="#L144">144</a> <em class="jxr_javadoccomment">	 * TODO Move this method in ConnectorReification.java</em>
<a class="jxr_linenumber" name="L145" href="#L145">145</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L146" href="#L146">146</a> <em class="jxr_javadoccomment">	 * @author ac221913</em>
<a class="jxr_linenumber" name="L147" href="#L147">147</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L148" href="#L148">148</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L149" href="#L149">149</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> generateCollaborationUse(<a href="../../../../../../../org/eclipse/papyrus/designer/components/FCM/Connector.html">Connector</a> connector) {
<a class="jxr_linenumber" name="L150" href="#L150">150</a> 
<a class="jxr_linenumber" name="L151" href="#L151">151</a> 		InteractionComponent connectorCompGen = connector.getIc();
<a class="jxr_linenumber" name="L152" href="#L152">152</a> 
<a class="jxr_linenumber" name="L153" href="#L153">153</a> 		<strong class="jxr_keyword">if</strong> (!(connectorCompGen instanceof InteractionComponent)) {
<a class="jxr_linenumber" name="L154" href="#L154">154</a> 			<strong class="jxr_keyword">return</strong>;
<a class="jxr_linenumber" name="L155" href="#L155">155</a> 		}
<a class="jxr_linenumber" name="L156" href="#L156">156</a> 		InteractionComponent connectorComp = connectorCompGen;
<a class="jxr_linenumber" name="L157" href="#L157">157</a> 		org.eclipse.uml2.uml.Collaboration connectionPattern =
<a class="jxr_linenumber" name="L158" href="#L158">158</a> 				connectorComp.getConnectionPattern();
<a class="jxr_linenumber" name="L159" href="#L159">159</a> 
<a class="jxr_linenumber" name="L160" href="#L160">160</a> 		<strong class="jxr_keyword">if</strong> (connectionPattern == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L161" href="#L161">161</a> 			FCMUtil.generateDefaultConnectionPattern(connectorComp);
<a class="jxr_linenumber" name="L162" href="#L162">162</a> 			connectionPattern = connectorComp.getConnectionPattern();
<a class="jxr_linenumber" name="L163" href="#L163">163</a> 		}
<a class="jxr_linenumber" name="L164" href="#L164">164</a> 
<a class="jxr_linenumber" name="L165" href="#L165">165</a> 		Class composite = (Class) connector.getBase_Connector().getOwner();
<a class="jxr_linenumber" name="L166" href="#L166">166</a> 		CollaborationUse collaborationUse;
<a class="jxr_linenumber" name="L167" href="#L167">167</a> 		RoleBindingTable bindingTable = getConnectorRoleBindings(connector);
<a class="jxr_linenumber" name="L168" href="#L168">168</a> 
<a class="jxr_linenumber" name="L169" href="#L169">169</a> 		<strong class="jxr_keyword">if</strong> (bindingTable == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L170" href="#L170">170</a> 			<strong class="jxr_keyword">return</strong>;
<a class="jxr_linenumber" name="L171" href="#L171">171</a> 		}
<a class="jxr_linenumber" name="L172" href="#L172">172</a> 
<a class="jxr_linenumber" name="L173" href="#L173">173</a> 		collaborationUse = composite.createCollaborationUse(<span class="jxr_string">"useOf"</span> + connectionPattern.getName()); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L174" href="#L174">174</a> 		collaborationUse.setType(connectionPattern);
<a class="jxr_linenumber" name="L175" href="#L175">175</a> 		<strong class="jxr_keyword">for</strong> (Iterator&lt;org.eclipse.uml2.uml.ConnectableElement&gt; i = bindingTable.iterator(); i.hasNext();) {
<a class="jxr_linenumber" name="L176" href="#L176">176</a> 			org.eclipse.uml2.uml.ConnectableElement role = i.next();
<a class="jxr_linenumber" name="L177" href="#L177">177</a> 			org.eclipse.uml2.uml.Dependency roleBinding;
<a class="jxr_linenumber" name="L178" href="#L178">178</a> 			roleBinding = collaborationUse.createRoleBinding(role.getName() + <span class="jxr_string">"RoleBinding"</span>); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L179" href="#L179">179</a> 			roleBinding.getSuppliers().add(role);
<a class="jxr_linenumber" name="L180" href="#L180">180</a> 			<strong class="jxr_keyword">for</strong> (Iterator&lt;org.eclipse.uml2.uml.NamedElement&gt; j = bindingTable.getEntry(role).iterator(); j.hasNext();) {
<a class="jxr_linenumber" name="L181" href="#L181">181</a> 				roleBinding.getClients().add(j.next());
<a class="jxr_linenumber" name="L182" href="#L182">182</a> 			}
<a class="jxr_linenumber" name="L183" href="#L183">183</a> 		}
<a class="jxr_linenumber" name="L184" href="#L184">184</a> 	}
<a class="jxr_linenumber" name="L185" href="#L185">185</a> 
<a class="jxr_linenumber" name="L186" href="#L186">186</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L187" href="#L187">187</a> <em class="jxr_javadoccomment">	 * Computes a RoleBindingTable for a given ConnectorComp</em>
<a class="jxr_linenumber" name="L188" href="#L188">188</a> <em class="jxr_javadoccomment">	 * Implies that a java class has been defined in FCMProfile.util for this ConnectorComp,</em>
<a class="jxr_linenumber" name="L189" href="#L189">189</a> <em class="jxr_javadoccomment">	 * and that it encapsulates corresponding role binding rule</em>
<a class="jxr_linenumber" name="L190" href="#L190">190</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L191" href="#L191">191</a> <em class="jxr_javadoccomment">	 * @author ac221913</em>
<a class="jxr_linenumber" name="L192" href="#L192">192</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L193" href="#L193">193</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L194" href="#L194">194</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/components/FCM/util/FCMUtil.html">RoleBindingTable</a> getConnectorRoleBindings(<a href="../../../../../../../org/eclipse/papyrus/designer/components/FCM/Connector.html">Connector</a> connector) {
<a class="jxr_linenumber" name="L195" href="#L195">195</a> 		InteractionComponent connectorCompGen = connector.getIc();
<a class="jxr_linenumber" name="L196" href="#L196">196</a> 
<a class="jxr_linenumber" name="L197" href="#L197">197</a> 		<strong class="jxr_keyword">if</strong> (!(connectorCompGen instanceof InteractionComponent)) {
<a class="jxr_linenumber" name="L198" href="#L198">198</a> 			<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L199" href="#L199">199</a> 		}
<a class="jxr_linenumber" name="L200" href="#L200">200</a> 		InteractionComponent type = connectorCompGen;
<a class="jxr_linenumber" name="L201" href="#L201">201</a> 
<a class="jxr_linenumber" name="L202" href="#L202">202</a> 		IExtensionRegistry reg = Platform.getExtensionRegistry();
<a class="jxr_linenumber" name="L203" href="#L203">203</a> 		IConfigurationElement[] configElements = reg.getConfigurationElementsFor(<span class="jxr_string">"fcmEmbeddingRule"</span>); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L204" href="#L204">204</a> 		<strong class="jxr_keyword">for</strong> (IConfigurationElement configElement : configElements) {
<a class="jxr_linenumber" name="L205" href="#L205">205</a> 			<strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="L206" href="#L206">206</a> 				<strong class="jxr_keyword">final</strong> String extConnName = configElement.getAttribute(<span class="jxr_string">"connectorName"</span>); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L207" href="#L207">207</a> 				<strong class="jxr_keyword">if</strong> (extConnName.equals(type.getBase_Class().getName())) {
<a class="jxr_linenumber" name="L208" href="#L208">208</a> 					<strong class="jxr_keyword">final</strong> Object obj = configElement.createExecutableExtension(<span class="jxr_string">"class"</span>); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L209" href="#L209">209</a> 					<strong class="jxr_keyword">if</strong> (obj instanceof IEmbeddingRule) {
<a class="jxr_linenumber" name="L210" href="#L210">210</a> 						<strong class="jxr_keyword">return</strong> ((IEmbeddingRule) obj).getRoleBindings(connector);
<a class="jxr_linenumber" name="L211" href="#L211">211</a> 					}
<a class="jxr_linenumber" name="L212" href="#L212">212</a> 				}
<a class="jxr_linenumber" name="L213" href="#L213">213</a> 			} <strong class="jxr_keyword">catch</strong> (CoreException exception) {
<a class="jxr_linenumber" name="L214" href="#L214">214</a> 				exception.printStackTrace();
<a class="jxr_linenumber" name="L215" href="#L215">215</a> 			}
<a class="jxr_linenumber" name="L216" href="#L216">216</a> 		}
<a class="jxr_linenumber" name="L217" href="#L217">217</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L218" href="#L218">218</a> 	}
<a class="jxr_linenumber" name="L219" href="#L219">219</a> 
<a class="jxr_linenumber" name="L220" href="#L220">220</a> 	<em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="L221" href="#L221">221</a> <em class="jxr_comment">	 * return a list of all rules based on containment packages of rules</em>
<a class="jxr_linenumber" name="L222" href="#L222">222</a> <em class="jxr_comment">	 * from owning elements</em>
<a class="jxr_linenumber" name="L223" href="#L223">223</a> <em class="jxr_comment">	 */</em>
<a class="jxr_linenumber" name="L224" href="#L224">224</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> EList&lt;ContainerRule&gt; getAllContainerRules(Element element) {
<a class="jxr_linenumber" name="L225" href="#L225">225</a> 		EList&lt;ContainerRule&gt; list = <strong class="jxr_keyword">new</strong> UniqueEList&lt;ContainerRule&gt;();
<a class="jxr_linenumber" name="L226" href="#L226">226</a> 		<strong class="jxr_keyword">if</strong> (element != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L227" href="#L227">227</a> 			<strong class="jxr_keyword">for</strong> (EObject eObj : element.getStereotypeApplications()) {
<a class="jxr_linenumber" name="L228" href="#L228">228</a> 				<strong class="jxr_keyword">if</strong> (eObj instanceof RuleApplication) {
<a class="jxr_linenumber" name="L229" href="#L229">229</a> 					list.addAll(((RuleApplication) eObj).getContainerRule());
<a class="jxr_linenumber" name="L230" href="#L230">230</a> 					<strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L231" href="#L231">231</a> 				}
<a class="jxr_linenumber" name="L232" href="#L232">232</a> 			}
<a class="jxr_linenumber" name="L233" href="#L233">233</a> 			element = element.getOwner();
<a class="jxr_linenumber" name="L234" href="#L234">234</a> 			<strong class="jxr_keyword">if</strong> (element != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L235" href="#L235">235</a> 				list.addAll(getAllContainerRules(element));
<a class="jxr_linenumber" name="L236" href="#L236">236</a> 			}
<a class="jxr_linenumber" name="L237" href="#L237">237</a> 		}
<a class="jxr_linenumber" name="L238" href="#L238">238</a> 		<strong class="jxr_keyword">return</strong> list;
<a class="jxr_linenumber" name="L239" href="#L239">239</a> 	}
<a class="jxr_linenumber" name="L240" href="#L240">240</a> 
<a class="jxr_linenumber" name="L241" href="#L241">241</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016&#x2013;2017 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
